#!/bin/sh
# 
#     !

#   ()
dev="ada0"

#   
tank="tank"

#   
if_lan="re0"

#  
ip_host="192.168.1.79"

#  
ip_mask="255.255.255.0"

#  
ip_gw="192.168.1.1"

#  
host_name="fb910.dnepr.piv"


### ===============  , ,  ===============================
#     3-  , ZFS
# C     
###

#    :
#        34 - 6            - free -
#        40 - 1024      1  freebsd-boot boot0
#      1064 - 984          - free -
#      2048 - 8388608   2  freebsd-swap
#   8390656 - xxxxxxxxx 3  freebsd-zfs
# xxxxxxxxx - xx           - free -

#  1
# 80G ,  156299308,   34.
# ..  156299308+34=156299342 
#   freebsd-zfs  
# 156299342-8390656=147908686 ,
# 147908686/8=18488585.75, .. 6    ,
#   "", 3-, ,
# c    4 (8 )
#  147908686-6=147908680 
#blk_long=147908680

#  2
# 500G ,  976770988,   34.
# ..  976770988+34=976771022 
#   freebsd-zfs  
# 976771022-8390656=968380366 ,
# 968380366/8=121047545.75, .. 6    ,
#   "", 3-, ,
# c    4 (8 )
#  968380366-6=968380360 
#blk_long=968380360

# ===========   ===================================================
####
#  
####
arhitect=`uname -m`
case "${arhitect}" in
i386)  #i386
       echo "script: arhitecture is i386"
       ;;
amd64) #amd64
       echo "script: arhitecture is amd64"
       ;;
*) #amd64
       echo "script: arhitecture is ${arhitect} not supported!"
       #        
       exit 1
       ;;
esac


#    
# i386, 4G
#sysctl hw.physmem | awk '{a = $2; print a}'
#3149967360
# amd64, 2G
#sysctl hw.physmem | awk '{a = $2; print a}'
#1817852256
# amd64, 4G
#sysctl hw.physmem | awk '{a = $2; print a}'
#3954008064
physmem=`sysctl hw.physmem | awk '{a = $2; print a}'`
physmemM=$((((${physmem})/1024)/1024))

echo "script: Create GPT, add partitions..."
gpart create -s gpt $dev

echo "script: add freebsd-boot partition boot0"
#   (1024*512=524288)? (   545  )
#  32 (64 ).
#   94   256 
gpart add -b 40 -s 1024 -t freebsd-boot -l boot0 ${dev}

echo "script: add freebsd-swap partition swap0"
#   ""  1024+40=1064  2048.
#    .
# (2048-1064=984   984*512=503808 )
#           4  8 .
# ..   40+1024=1064 (1064/8=133, ..   8).
#    2048  8388608  /8=1048576,  
gpart add -b 2048 -s 4G -t freebsd-swap -l swap0 ${dev}

####
#   3 ,  , ZFS
####

#         ()
blk_begin=`gpart show ${dev} | grep '=>' | awk '{a = $2; print a}'`
echo "script: blk_begin=${blk_begin}"
blk_end=`gpart show ${dev} | grep '=>' | awk '{a = $3; print a}'`
echo "script: blk_end=${blk_end}"

#        (freebsd-swap)
blk_swop_begin=`gpart show ${dev} | grep 'freebsd-swap' | awk '{a = $1; print a}'`
echo "script: blk_swop_begin=${blk_swop_begin}"
blk_swop_end=`gpart show ${dev} | grep 'freebsd-swap' | awk '{a = $2; print a}'`
echo "script: blk_swop_end=${blk_swop_end}"

#    ZFS
blk_zfs_begin=$((${blk_swop_begin} + ${blk_swop_end}))
echo "script: blk_zfs_begin=${blk_zfs_begin}"

#      ZFS    8  (4K)
blk_long=$(( (((${blk_begin}+${blk_end})-${blk_zfs_begin})/8)*8 ))
echo "script: blk_long=${blk_long}"

echo "script: add freebsd-zfs partition data0, long is ${blk_long} blocks"
#     ,    :
# (2048+8388608=8390656)/8=1048832, a.
#    ,     4.
# .  ,  blk_long=
gpart add -s ${blk_long} -t freebsd-zfs -l data0 ${dev}

echo " "
echo "script: GPT on $dev created, partitions added."
echo " "

sleep 5

#    
gpart bootcode -b /boot/pmbr -p /boot/gptzfsboot -i 1 ${dev}

gpart show ${dev}
sleep 3
gpart show -l ${dev}
sleep 5

# Create ZFS pool
echo "script: Create ZFS pool..."

#  
gnop create -S 4096 /dev/gpt/data0

#      4K
zpool create -f -o altroot=/mnt -o cachefile=/var/tmp/zpool.cache ${tank} /dev/gpt/data0.nop
zpool export ${tank}
gnop destroy /dev/gpt/data0.nop
mkdir /tmp/${tank}
zpool import -o altroot=/tmp/${tank} -o cachefile=/var/tmp/zpool.cache ${tank}

# ,   
zpool set bootfs=${tank} ${tank}

sleep 3

# Create ZFS-filesystem
echo "script: Create filesystem..."

#   ?    ?  ?
#zfs set atime=off ${tank}

#    .
zfs set checksum=fletcher4 ${tank}

#            
zfs create ${tank}/usr
zfs create ${tank}/usr/home
#zfs create -o compression=off -o setuid=off ${tank}/usr/ports
zfs create ${tank}/usr/ports
#zfs create -o compression=off -o exec=off -o setuid=off ${tank}/usr/ports/distfiles
#zfs create -o compression=off -o exec=off -o setuid=off ${tank}/usr/ports/packages
#zfs create -o compression=on -o exec=off -o setuid=off ${tank}/usr/src
zfs create ${tank}/usr/src
#zfs create -o compression=on -o exec=on -o setuid=off ${tank}/tmp
zfs create ${tank}/tmp
zfs create ${tank}/var
#zfs create -o compression=on -o exec=off -o setuid=off ${tank}/var/crash
#zfs create -o exec=off -o setuid=off ${tank}/var/db
#zfs create -o compression=on -o exec=on -o setuid=off ${tank}/var/db/pkg
#zfs create -o exec=off -o setuid=off ${tank}/var/empty
#zfs create -o compression=on -o exec=off -o setuid=off ${tank}/var/log
#zfs create -o compression=gzip -o exec=off -o setuid=off ${tank}/var/mail
#zfs create -o exec=off -o setuid=off ${tank}/var/run
#zfs create -o compression=on -o exec=on -o setuid=off ${tank}/var/tmp
zfs create ${tank}/var/tmp

chmod 1777 //tmp/${tank}/tmp
chmod 1777 //tmp/${tank}/var/tmp
cd //tmp/${tank}
ln -s usr/home home
sleep 3
#clear

echo "script: ZFS-filesystem structure:"
zfs list
sleep 15
#clear

#   
echo "script: Install base system..."

cd /usr/freebsd-dist
# ,   ,    LiveCD,    Shell
export DESTDIR=/tmp/${tank}
#setenv DESTDIR /tmp/${tank}

case "${arhitect}" in
i386)  # for i386
#for file in base.txz doc.txz kernel.txz ports.txz src.txz; do (cat $file | tar --unlink -xpJf - -C ${DESTDIR:-/}) ; done
for file in base.txz doc.txz kernel.txz           src.txz; do (cat $file | tar --unlink -xpJf - -C ${DESTDIR:-/}) ; done
       ;;
amd64) # for amd64
#for file in base.txz doc.txz kernel.txz ports.txz src.txz lib32.txz; do (cat $file | tar --unlink -xpJf - -C ${DESTDIR:-/}); done
for file in base.txz doc.txz kernel.txz           src.txz lib32.txz; do (cat $file | tar --unlink -xpJf - -C ${DESTDIR:-/}); done
       ;;
esac

echo "script: System has bin installed..."
sleep 1
#echo "script: Copy zpool cache..."
#  zpool.cache   .     ,   )
#cp /var/tmp/zpool.cache /mnt/boot/zfs/zpool.cache

sleep 1
# install base config
echo "script: Install base config..."

cat << EOF > /tmp/${tank}/etc/rc.conf
# ---------- ZFS -----------------
zfs_enable="YES"
# --------------------------------
#keymap="ru.koi8-r.kbd"
# ---- LOCAL win1251 ------------- 
keymap="ru.cp1251" 
scrnmap="win2cpp866" 
font8x16="cp866b-8x16" 
font8x14="cp866-8x14" 
font8x8="cp866-8x8"

# ---- LOCAL UTF8 ------------- 
#keymap="ru.koi8-r"
#font8x8="cp866-8x8"
#font8x14="cp866-8x14"
#font8x16="cp866b-8x16"
#scrnmap="koi8-r2cp866"

# ------- NET OPTIONS ------------
EOF

#ip_gw="192.168.16.1"
echo "hostname=\"${host_name}\"" >> /tmp/${tank}/etc/rc.conf
echo '' >> /tmp/${tank}/etc/rc.conf
echo '#---- LAN ----------------------------------' >> /tmp/${tank}/etc/rc.conf
echo "ifconfig_${if_lan}=\" inet ${ip_host} netmask ${ip_mask}\"" >> /tmp/${tank}/etc/rc.conf
echo '' >> /tmp/${tank}/etc/rc.conf
echo '#---- GATEWAY def --------------------------' >> /tmp/${tank}/etc/rc.conf
echo "defaultrouter=\"${ip_gw}\"" >> /tmp/${tank}/etc/rc.conf
echo ''

cat << EOF >> /tmp/${tank}/etc/rc.conf
# -------- ssh -------------------
sshd_enable="YES"

#---- IPFW -------------------------------
firewall_enable="YES"
firewall_type="open" 

#---- LINUX ------------------------------
#linux_enable="YES" 

# -------- other ------------------
moused_enable="YES"
powerd_enable="YES"
# Set dumpdev to "AUTO" to enable crash dumps, "NO" to disable
dumpdev="AUTO"

# ----------- console video --------------
# for get me mode insert from real console # vidcontrol -i mode | more
#allscreens_flags="-t 5 -f 8x16 cp866-8x16.fnt MODE_283"
#allscreens_flags="-f 8x16 cp866-8x16.fnt MODE_283"

# ----------- sreen sever --------------
#blank_saver.ko    This screen saver simply blanks the screen.
#beastie_saver.ko  Animated graphical BSD Daemon.
#daemon_saver.ko   Animated BSD Daemon screen saver.
#dragon_saver.ko   Draws a random dragon curve.
#fade_saver.ko     The screen will gradually fade away.
#fire_saver.ko     A fire which becomes higher as load increases.
#green_saver.ko    The screen will be blanked, similar to blank_saver.ko.
#                  If the monitor and the video card's BIOS support it the
#                  screen will also be powered off.
#logo_saver.ko     Animated graphical FreeBSD logo.
#rain_saver.ko     Draws a shower on the screen.
#snake_saver.ko    Draws a snake of string.
#star_saver.ko     Twinkling stars.
#warp_saver.ko     Streaking stars.
#saver=fire_saver

#blanktime=60

# --- DNS cahe mode for resolve ---------
named_enable="YES"

# --- for blutooth ---------
#hcsecd_enable="YES"

#--- PPP config for WAN over UTEL ----------
#ppp_enable="YES"
#ppp_mode="background"
#ppp_profile="utel"

EOF

case "${arhitect}" in
i386)  # for i386
  echo 'zfs_load="YES"' > /tmp/${tank}/boot/loader.conf
  echo "vfs.root.mountfrom=\"zfs:${tank}\"" >> /tmp/${tank}/boot/loader.conf
  echo 'vfs.zfs.prefetch_disable=1' >> /tmp/${tank}/boot/loader.conf
#  physmem

#   (  -  i386):
#  kmem  512 ,
#    " "  ""  kmem_suballoc.
#  ,        512 ,
#    ( 1)     :
#options KVA_PAGES=512
#  KVA_PAGES=256,     .

#for 768 Megs of physical RAM
  #echo 'vm.kmem_size="330M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vm.kmem_size_max="330M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc="40M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc_max="40M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.vdev.cache.size="5M"' >> /tmp/${tank}/boot/loader.conf
# 1  :
  echo 'vm.kmem_size="408M"' >> /tmp/${tank}/boot/loader.conf
  echo 'vm.kmem_size_max="408M"' >> /tmp/${tank}/boot/loader.conf
  echo 'vfs.zfs.arc="60M"' >> /tmp/${tank}/boot/loader.conf
  echo 'vfs.zfs.arc_max="60M"' >> /tmp/${tank}/boot/loader.conf
  echo 'vfs.zfs.vdev.cache.size="10M"' >> /tmp/${tank}/boot/loader.conf
# 2  :
  #echo 'vm.kmem_size="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vm.kmem_size_max="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc="80M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc_max="80M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.vdev.cache.size="30M"' >> /tmp/${tank}/boot/loader.conf
       ;;
amd64) # # for amd64
  echo 'zfs_load="YES"' > /tmp/${tank}/boot/loader.conf
  echo "vfs.root.mountfrom=\"zfs:${tank}\"" >> /tmp/${tank}/boot/loader.conf
  echo 'vfs.zfs.prefetch_disable=1' >> /tmp/${tank}/boot/loader.conf
#  physmem
# 1  :
  #echo 'vm.kmem_size="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vm.kmem_size_max="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc="80M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc_max="80M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.vdev.cache.size="20M"' >> /tmp/${tank}/boot/loader.conf
# 2  :
  #echo 'vm.kmem_size="1024M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vm.kmem_size_max="1024M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.arc_max="512M"' >> /tmp/${tank}/boot/loader.conf
  #echo 'vfs.zfs.vdev.cache.size="10M"' >> /tmp/${tank}/boot/loader.conf
       ;;
esac

#     ''FreeBSD'',
#      ,
#   ,    
#    FreeBSD.
echo 'loader_logo="beastie"' >> /tmp/${tank}/boot/loader.conf
echo 'loader_color="YES"' >> /tmp/${tank}/boot/loader.conf

sleep 1
echo "script: Make fstab..."

cat << EOF > /tmp/${tank}/etc/fstab
# Device        Mountpoint   FStype   Options   Dump   Pass#
/dev/gpt/swap0  none         swap     sw        0      0
EOF

echo "script: Change file /etc/ssh/sshd_config..."
echo 'Port 1101' >> /tmp/${tank}/etc/ssh/sshd_config
echo "ListenAddress ${ip_host}" >> /tmp/${tank}/etc/ssh/sshd_config
echo 'Protocol 2' >> /tmp/${tank}/etc/ssh/sshd_config
echo 'LoginGraceTime 2m' >> /tmp/${tank}/etc/ssh/sshd_config
echo 'PermitRootLogin yes' >> /tmp/${tank}/etc/ssh/sshd_config
echo 'UseLogin yes' >> /tmp/${tank}/etc/ssh/sshd_config
echo 'AllowUsers root teg' >> /tmp/${tank}/etc/ssh/sshd_config

sleep 5
#clear


#      "/boot/zfs/zpool.cache"
#    
#zfs set mountpoint=/tmp/root ${tank}

echo "script: Copy zpool cache..."
#  zpool.cache   .     ,   )
cp /var/tmp/zpool.cache /tmp/${tank}/boot/zfs/zpool.cache

# correct ZFS mount points and quotas
echo "script: Set mount points and quotas..."
zfs unmount -af
zfs set mountpoint=legacy ${tank}
zfs set mountpoint=/usr ${tank}/usr
#zfs set quota=4G ${tank}/tmp && zfs set mountpoint=/tmp ${tank}/tmp
zfs set mountpoint=/tmp ${tank}/tmp
#zfs set quota=4G ${tank}/var && zfs set mountpoint=/var ${tank}/var
zfs set mountpoint=/var ${tank}/var

zfs list
sleep 1
zpool status
sleep 1
#   .
echo 'The script finished operation!'
# !        "root"
#     :
echo 'Please! After reboot and the first input under the user "root"'
echo ' do not forget to execute following commands:'
echo ' '
echo 'Choice your time zone:'
echo '# tzsetup'
echo ' '
echo 'Generate file /etc/mail/aliases.db:'
echo '# cd /etc/mail'
echo '# make aliases'
echo ' '
echo 'Creation of the password for the superuser root:'
echo '# passwd'
echo ' '
echo 'Adding of users in system'
echo '# adduser'
echo ' '
sleep 15
echo "script: Good-bye."
